#include 	<sys/bios.h>
#include	<stdlib.h>

#include	"pattern.h"
#include	"S_mouse.h"

static	int	vmap[17][28];

/*
	wʒuɃhbgu(\Ȃ)
*/
int VOn(int x, int y)
{
	int		cx, cy, sh;

	cx = x >> 1;
	cy = y >> 1;
	sh = (x & 0x01) + ((y & 0x01) << 1);
	return (vmap[cy][cx] |= (0x01 << sh));
}

/*
	wʒũhbg(\Ȃ)
*/
int VOff(int x, int y)
{
	int		cx, cy, sh;

	cx = x >> 1;
	cy = y >> 1;
	sh = (x & 0x01) + ((y & 0x01) << 1);
	return (vmap[cy][cx] &= ~(0x01 << sh));
}

/*
	wʒũhbg擾
*/
int VGet(int x, int y)
{
	int		cx, cy, sh;

	cx = x >> 1;
	cy = y >> 1;
	sh = (x & 0x01) + ((y & 0x01) << 1);
	return (vmap[cy][cx] & (0x01 << sh)) ? 1 : 0;
}

/*
	wʒuɃZu
*/
void CellSet(int x, int y)
{
	if(x < 0) x += 56;
	if(y < 0) y += 34;
	if(x > 55) x -= 56;
	if(y > 33) y -= 34;
    screen_set_char(SCREEN2, x >> 1, (y >> 1) + 1, 1, 1, pat + VOn(x, y));
}

/*
	wʒũZ
*/
void CellReset(int x, int y)
{
	if(x < 0) x += 56;
	if(y < 0) y += 34;
	if(x > 55) x -= 56;
	if(y > 33) y -= 34;
    screen_set_char(SCREEN2, x >> 1, (y >> 1) + 1, 1, 1, pat + VOff(x, y));
}

/*
	wʒũZ擾
*/
int GetCell(int x, int y)
{
	if(x < 0) x += 56;
	if(y < 0) y += 34;
	if(x > 55) x -= 56;
	if(y > 33) y -= 34;
	return VGet(x, y);
}

/*
	wʒu̎͂̃Z擾
*/
int SumCell(int x, int y)
{
	int		sum;

	sum = GetCell(x - 1, y - 1) +
		  GetCell(x    , y - 1) +
		  GetCell(x + 1, y - 1) +
		  GetCell(x - 1, y    ) +
		  GetCell(x + 1, y    ) +
		  GetCell(x - 1, y + 1) +
		  GetCell(x    , y + 1) +
		  GetCell(x + 1, y + 1);

	return sum;
}

/*
	i߂
*/
int CellGen()
{
	int		x, y;
	int		cells;
	static int	field[56][34];

	/*
		Z̐Ǝ
	*/
	cells = 0;
	for(y = 0; y < 34; y++) {
		for(x = 0; x < 56;  x++) {
			switch(SumCell(x, y)) {
				case 2:
					field[x][y] = VGet(x, y);	/* ω */
					break;
				case 3:
					field[x][y] = 1;			/*  */
					break;
				default:
					field[x][y] = 0;			/*  */
			}
			cells += field[x][y];
		}
	}

	/*
		ZtHgԍɕϊ
	*/
	for(y = 0; y < 34; y += 2) {
		for(x = 0; x < 56; x += 2) {
			vmap[y >> 1][x >> 1] = (field[x    ][y    ] ? 1 : 0) + 
								   (field[x + 1][y    ] ? 2 : 0) +
								   (field[x    ][y + 1] ? 4 : 0) +
								   (field[x + 1][y + 1] ? 8 : 0);
		}
	}

	/*
		XN[ɓ]
	*/
	screen_set_char(SCREEN2, 0, 1, 28, 17, vmap);

	return cells;
}

/*
	j[\
*/
void set_menu(int mno, int mode)
{
	if(mode)
		font_set_color(0x0c);	/* ] */
	else
		font_set_color(0x03);	/* ʏ */

	switch(mno)
	{
		case 0:
			text_put_string(9,  8, " SET CELL ");
			break;
		case 1:
			text_put_string(9, 10, "  RANDOM  ");
			break;
		case 2:
			text_put_string(9, 12, "   EXIT   ");
			break;
	}

	font_set_color(0x03);
}

/*
	ZҏW
*/
void edit_cell()
{
	unsigned	key;
	int			cx, cy, mx, my;

	palette_set_color( 0, 0x5520);
	text_put_string(0, 0, "*                   ");
	cx = 28;
	cy = 15;
	mx = (cx << 2) + 2;
	my = ((cy + 2) << 2) + 2;

	key = key_hit_check();

	while(1)
	{
		sprite_set_location(0, mx, my);

		/*
			L[
		*/
		key = key_hit_check_with_repeat();
		if(key != 0)
		{
			if(key & KEY_START)
			{
				break;
			}
			else if(key & KEY_A)
			{
				CellSet(cx, cy);
			}
			else if(key & KEY_B)
			{
				CellReset(cx, cy);
			}
			else if(key & KEY_UP2)
			{
				CellSet(cx    , cy - 1);
				CellSet(cx    , cy    );
				CellSet(cx + 1, cy    );
				CellSet(cx + 1, cy + 1);
				CellSet(cx - 1, cy + 1);
			}
			else if(key & KEY_RIGHT2)
			{
				CellSet(cx + 1, cy    );
				CellSet(cx    , cy    );
				CellSet(cx    , cy + 1);
				CellSet(cx - 1, cy + 1);
				CellSet(cx - 1, cy - 1);
			}
			else if(key & KEY_DOWN2)
			{
				CellSet(cx    , cy + 1);
				CellSet(cx    , cy    );
				CellSet(cx - 1, cy   );
				CellSet(cx - 1, cy - 1);
				CellSet(cx + 1, cy - 1);
			}
			else if(key & KEY_LEFT2)
			{
				CellSet(cx - 1, cy    );
				CellSet(cx    , cy    );
				CellSet(cx    , cy - 1);
				CellSet(cx + 1, cy - 1);
				CellSet(cx + 1, cy + 1);
			}
	
			if(key & KEY_UP1)
			{
				cy = ((cy <= 0) ? 33 : cy - 1);
				mx = (cx << 2) + 2;
				my = ((cy + 2) << 2) + 2;
			}
			else if(key & KEY_DOWN1)
			{
				cy = ((cy >= 33) ? 0 : cy + 1);
				mx = (cx << 2) + 2;
				my = ((cy + 2) << 2) + 2;
			}
			else if(key & KEY_LEFT1)
			{
				cx = ((cx <= 0) ? 55 : cx - 1);
				mx = (cx << 2) + 2;
				my = ((cy + 2) << 2) + 2;
			}
			else if(key & KEY_RIGHT1)
			{
				cx = ((cx >= 55) ? 0 : cx + 1);
				mx = (cx << 2) + 2;
				my = ((cy + 2) << 2) + 2;
			}
		}

		/*
			}EX
		*/
		get_mouse_status();
		mx += MOUSE_DX;
		my += MOUSE_DY;
		if((mx < 0)||(mx >= 224)) mx -= MOUSE_DX;
		if((my < 0)||(my >= 144)) my -= MOUSE_DY;

		if((mx < 8)&&(my < 8)&&(MOUSE_LEFT_DOWN))
		{
			while(MOUSE_LEFT)
			{
				get_mouse_status();
			}
			break;
		}

		cx = (mx >> 2);
		cy = (my >> 2) - 2;
		if(cy < 0) cy = 0;

		if(MOUSE_LEFT)
		{
			CellSet(cx, cy);
		}

		if(MOUSE_RIGHT)
		{
			CellReset(cx, cy);
		}

		sys_wait(1);
	}

	sprite_set_location(0, 224, 0);
	palette_set_color( 0, 0x7520);
}

/*
	_ɃZu
*/
void random_cell()
{
	int		i;

	for(i = 1; i < 500; i++) {
		CellSet(rand() % 56, rand() % 34);
	}
	sprite_set_location(0, 224, 0);
}

/*
	C
*/
void main(void)
{
	int			age, cells;
	int			sel;
	unsigned	key;

	static int cursor[8]
		= {	0xC0C0, 0xF0F0, 0x7E7E, 0x7C7C, 0x3C3C, 0x3E3E, 0x2727, 0x0202 };

	/*
		̏
	*/
	srand(rtc_get_datetime(RTC_DATE) +
		  rtc_get_datetime(RTC_HOUR) +
		  rtc_get_datetime(RTC_MIN) +
		  rtc_get_datetime(RTC_SEC));

	/*
		ʂ̏
	*/
	display_control(DCM_SCR1|DCM_SCR2|DCM_SPR);
	lcd_set_color(0x6420, 0xFCA8);
	palette_set_color( 0, 0x7520);	/* LN^p */
	palette_set_color(12, 0x7520);	/* XvCgp */
	text_set_screen(SCREEN2);
	text_screen_init();

	/*
		j[
	*/
	text_put_string(4, 3, " THE GAME OF LIFE ");
	set_menu(0, 1);
	set_menu(1, 0);
	set_menu(2, 0);

	/*
		j[I
	*/
	sel = 0;
	while(1)
	{
	    key = key_wait();
		if(key & KEY_DOWN1)
		{
			if(sel == 2)
			{
				set_menu(sel, 0);
				set_menu(0, 1);
				sel = 0;
			}
			else
			{
				set_menu(sel, 0);
				set_menu(++sel, 1);
			}
		}
		else if(key & KEY_UP1)
		{
			if(sel == 0)
			{
				set_menu(sel, 0);
				set_menu(2, 1);
				sel = 2;
			}
			else
			{
				set_menu(sel, 0);
				set_menu(--sel, 1);
			}
		}
		else if(key & KEY_A)
		{
			break;
		}
		else
		{
			return;
		}
	}

	if(sel == 2)
	{
		return;		/* EXIT */
	}

	/*
		LN^p^[ݒ
	*/
	font_set_monodata(0, 16, bmp_pat);		/* 0`15 */

	/*
		}EXJ[\ݒ
	*/
	font_set_colordata(16, 1, cursor);		/* 16 */
	sprite_set_range(0, 1);
	sprite_set_char(0, 0x2810);
	sprite_set_location(0, 112, 72);

	/*
		eLXgEBhEݒiŏŝ݃eLXgj
	*/
	text_window_init(0, 0, 28, 1, 32);		/* 32` */

	/*
		LN^0i󔒁jŉʂ𖄂߂
	*/
	screen_fill_char(SCREEN2, 0, 1, 32, 17, 0);

	/*
		zVRAM
	*/
	memset(vmap, 0, sizeof(vmap));

	/*
		}EXhCo풓
	*/
	mousedrv_init();

	/*
		Z̏
	*/
	switch(sel)
	{
		case 0:
			edit_cell();		/* 蓮 */
			break;
		case 1:
			random_cell();		/* _ */
	}

	text_put_string(0, 0, "AGE:00000 CELLS:0000");
	age = 1;				/* JE^ */
	cells = CellGen();		/* ɐi߂ */

	/*
		{^܂Ń[v
	*/
	while(1) {
		/*
			ƃZ\
		*/
		text_put_numeric(4, 0, 5, NUM_PADZERO | NUM_ALIGN_RIGHT, age++);
		text_put_numeric(16, 0, 4, NUM_PADZERO | NUM_ALIGN_RIGHT, cells);

		/*
			L[`FbN
		*/
		key = key_hit_check();
		if(key != 0)
		{
			if(key & KEY_START)
			{
				break;
			}
			else
			{
				edit_cell();
				text_put_string(0, 0, "AGE:      CELLS:    ");
			}
		}

		/*
			}EX̓`FbN
		*/
		get_mouse_status();
		if((MOUSE_LEFT_UP)||(MOUSE_RIGHT_UP))
		{
			edit_cell();
			text_put_string(0, 0, "AGE:      CELLS:    ");
		}

		cells = CellGen();	/* ɐi߂ */
		sys_wait(1);
	}

	/*
		}EXhCo풓
	*/
	mousedrv_release();
}
