/*
 * VA}EXhCo for WonderWitch ver 0.8
 * 2000.08.22 (C) 
 * http://ha6.seikyou.ne.jp/home/sasao/junkhard/
 * \[X̉ρEĔzz͂Rɂǂ
 */
#ifndef _S_MOUSE_H_
#define _S_MOUSE_H_

#include <sys/bios.h>

void mousedrv_init();			/* }EXhCo풓 */
void mousedrv_release();		/* }EXhCoJ   */
void get_mouse_status();			/* }EX̏ԂO[oϐɎ擾 */
void far mouse_receive_interrupt();	/* VA|[gM荞݃[` */

/* get_mouse_status() R[邽т */
/* XVO[oϐ                */

static int MOUSE_DX=0;		/* Xω */
static int MOUSE_DY=0;		/* Yω */
static int MOUSE_LEFT=0;	/* {^ 1:ON, 0:OFF */
static int MOUSE_RIGHT=0;	/* E{^ 1:ON, 0:OFF */
static int MOUSE_LEFT_UP=0;
static int MOUSE_LEFT_DOWN=0;
static int MOUSE_RIGHT_UP=0;
static int MOUSE_RIGHT_DOWN=0;

/* Ŏgp邽߂̃O[oϐ */
/* ([U[͂ύXȂ) */

static int MOUSE_DX_INTERNAL = 0;
static int MOUSE_DY_INTERNAL = 0;
static int MOUSE_LEFT_INTERNAL = 0;
static int MOUSE_RIGHT_INTERNAL =0;
static int MOUSE_LEFT_KEEP_INTERNAL = 0;
static int MOUSE_RIGHT_KEEP_INTERNAL =0;
static int MOUSE_LEFT_UP_INTERNAL=0;
static int MOUSE_LEFT_DOWN_INTERNAL=0;
static int MOUSE_RIGHT_UP_INTERNAL=0;
static int MOUSE_RIGHT_DOWN_INTERNAL=0;
static int SYSTEM_BAUDRATE;
static int COMM_HOOK_FLAG = 0;


/*---------------------------------------*/
/* mousedrv_init                         */
/* }EXhCo[`          */
/*---------------------------------------*/
void mousedrv_init(void)
{
	static intvector_t iv;

	if ( COMM_HOOK_FLAG==0 ){

		/* COM |[g I[v */
		SYSTEM_BAUDRATE = comm_get_baudrate();
		comm_set_baudrate(COMM_SPEED_9600);
		comm_open();
		comm_set_timeout(0,1);

#ifdef LSI_C_WW
		iv.callback = (void (near *)())FP_OFF(mouse_receive_interrupt);
		iv.cs =  _asm_inline("mov ax, cs");
		iv.ds =  _asm_inline("mov ax, ds");
#else
		iv.callback = (void (near *)())mouse_receive_interrupt;
		iv.cs = _CS;
		iv.ds = _DS;
#endif

		/* 荞݃tbNZbg */
		sys_interrupt_set_hook(SYS_INT_RECEIVEREADY, &iv, NULL);
		COMM_HOOK_FLAG = 1;
	}
}

/*---------------------------------------*/
/* mousedrv_release                      */
/* }EXhCoJ[`            */
/*---------------------------------------*/
void mousedrv_release(void)
{

	if ( COMM_HOOK_FLAG ){

		/* 荞݃tbNZbg */
		sys_interrupt_reset_hook(SYS_INT_RECEIVEREADY, NULL);

		/* COM |[g N[Y */
		comm_set_baudrate(SYSTEM_BAUDRATE);
		comm_close();
		COMM_HOOK_FLAG = 0;
	}
}

/*---------------------------------------*/
/* mouse_receive_interrupt               */
/* VA|[gM荞݃[`    */
/*---------------------------------------*/
void far mouse_receive_interrupt(void)
{
	static int mouse_seq=0,dx=0,dy=0,LR=0;
	static int c;

	c = comm_receive_char();
	switch (c) {
		case ERR_SIO_TIMEOUT:
			break;
		default:
			if ( (c & 0x40) == 0x40 )mouse_seq = 0; else mouse_seq++;
			if (mouse_seq == 0){
				dx = (c & 0x03)<<6;
				dy = (c & 0x0c)<<4;
				LR = (c & 0x30)>>4;
			}
			if (mouse_seq == 1){
				dx = dx | (c & 0x3f);
				if (dx>127) dx = dx-256;
			}
			if (mouse_seq == 2){
				dy = dy | (c & 0x3f);
				if (dy>127) dy = dy-256;
				MOUSE_DX_INTERNAL += dx;
				MOUSE_DY_INTERNAL += dy;
				MOUSE_LEFT_INTERNAL  = LR >> 1;
				MOUSE_RIGHT_INTERNAL = LR & 1;
				if ((!MOUSE_LEFT_INTERNAL)&&(MOUSE_LEFT_KEEP_INTERNAL)){
					MOUSE_LEFT_UP_INTERNAL = 1;
				}
				if ((MOUSE_LEFT_INTERNAL)&&(!MOUSE_LEFT_KEEP_INTERNAL)){
					MOUSE_LEFT_DOWN_INTERNAL = 1;
				}
				if ((!MOUSE_RIGHT_INTERNAL)&&(MOUSE_RIGHT_KEEP_INTERNAL)){
					MOUSE_RIGHT_UP_INTERNAL = 1;
				}
				if ((MOUSE_RIGHT_INTERNAL)&&(!MOUSE_RIGHT_KEEP_INTERNAL)){
					MOUSE_RIGHT_DOWN_INTERNAL = 1;
				}
				MOUSE_LEFT_KEEP_INTERNAL = MOUSE_LEFT_INTERNAL;
				MOUSE_RIGHT_KEEP_INTERNAL = MOUSE_RIGHT_INTERNAL;
			}
	}
	
}

/*-----------------------------------------*/
/* get_mouse_status                        */
/* VA}EX̏ԂԂ              */
/* [߂l:O[oϐ]                 */
/* MOUSE_DX: OR[Xړ */
/* MOUSE_DY:                   Y           */
/* MOUSE_LEFT:   {^ 1:ON,  0:OFF     */
/* MOUSE_RIGHT:  E{^ 1:ON,  0:OFF     */
/*-----------------------------------------*/
void get_mouse_status(void){
	MOUSE_DX = MOUSE_DX_INTERNAL;
	MOUSE_DY = MOUSE_DY_INTERNAL;
	MOUSE_DX_INTERNAL = 0;
	MOUSE_DY_INTERNAL = 0;

	MOUSE_LEFT  = MOUSE_LEFT_INTERNAL;
	MOUSE_RIGHT = MOUSE_RIGHT_INTERNAL;

	MOUSE_LEFT_UP = MOUSE_LEFT_UP_INTERNAL;
	MOUSE_LEFT_DOWN = MOUSE_LEFT_DOWN_INTERNAL;
	MOUSE_RIGHT_UP = MOUSE_RIGHT_UP_INTERNAL;
	MOUSE_RIGHT_DOWN = MOUSE_RIGHT_DOWN_INTERNAL;
	MOUSE_LEFT_UP_INTERNAL = 0;
	MOUSE_LEFT_DOWN_INTERNAL = 0;
	MOUSE_RIGHT_UP_INTERNAL = 0;
	MOUSE_RIGHT_DOWN_INTERNAL = 0;
}

#endif /*_S_MOUSE_H_*/
